/* view.c generated by valac 0.56.18, the Vala compiler
 * generated from view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "libsudoku.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_NUMBER_PICKER (sudoku_number_picker_get_type ())
#define SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPicker))
#define SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))
#define IS_SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_NUMBER_PICKER))
#define IS_SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_NUMBER_PICKER))
#define SUDOKU_NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))

typedef struct _SudokuNumberPicker SudokuNumberPicker;
typedef struct _SudokuNumberPickerClass SudokuNumberPickerClass;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
typedef enum  {
	ZOOM_LEVEL_NONE = 0,
	ZOOM_LEVEL_SMALL = 1,
	ZOOM_LEVEL_MEDIUM = 2,
	ZOOM_LEVEL_LARGE = 3
} ZoomLevel;

#define TYPE_ZOOM_LEVEL (zoom_level_get_type ())
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_EARMARK_MODE_PROPERTY,
	SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY,
	SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY,
	SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_HAS_SELECTION_PROPERTY,
	SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL,
	SUDOKU_VIEW_NUM_SIGNALS
};
static guint sudoku_view_signals[SUDOKU_VIEW_NUM_SIGNALS] = {0};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	SudokuNumberPicker* number_picker;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	GSettings* settings;
	GtkEventControllerKey* key_controller;
	GtkEventControllerFocus* focus_controller;
	SudokuGame* game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	SudokuFrame* frame;
	GtkLabel* paused_label;
	gboolean _earmark_mode;
	gboolean _autoclean_earmarks;
	gboolean _number_picker_second_click;
	gboolean _highlight_row_column;
	gboolean _highlight_block;
	gboolean _highlight_numbers;
	gdouble _value_zoom_multiplier;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_earmark_warnings;
	gboolean _solution_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
	gboolean _has_selection;
	ZoomLevel _zoom_level;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuNumberPicker, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN GType zoom_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
VALA_EXTERN SudokuNumberPicker* sudoku_number_picker_new (SudokuGame* game);
VALA_EXTERN SudokuNumberPicker* sudoku_number_picker_construct (GType object_type,
                                                    SudokuGame* game);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
static void sudoku_view_value_changed_cb (SudokuView* self,
                                   gint row,
                                   gint col,
                                   gint old_val,
                                   gint new_val);
static void _sudoku_view_value_changed_cb_sudoku_board_value_changed (SudokuBoard* _sender,
                                                               gint row,
                                                               gint col,
                                                               gint old_val,
                                                               gint new_val,
                                                               gpointer self);
static void sudoku_view_earmark_changed_cb (SudokuView* self,
                                     gint row,
                                     gint col,
                                     gint num,
                                     gboolean enabled);
static void _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                                   gint row,
                                                                   gint col,
                                                                   gint num,
                                                                   gboolean enabled,
                                                                   gpointer self);
static void sudoku_view_selection_changed_cb (SudokuView* self,
                                       gint old_row,
                                       gint old_col,
                                       gint new_row,
                                       gint new_col);
static void _sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                      gint old_row,
                                                                      gint old_col,
                                                                      gint new_row,
                                                                      gint new_col,
                                                                      gpointer self);
static void sudoku_view_paused_cb (SudokuView* self);
static void _sudoku_view_paused_cb_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static gboolean sudoku_view_key_pressed_cb (SudokuView* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void __lambda5_ (SudokuView* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda5__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                   gpointer self);
static void sudoku_view_update_warnings (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
static SudokuCell* sudoku_view_get_selected_cell (SudokuView* self);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
static void sudoku_view_insert_key (SudokuView* self,
                             gint key,
                             gboolean control_pressed);
VALA_EXTERN gboolean sudoku_view_get_earmark_mode (SudokuView* self);
VALA_EXTERN void sudoku_number_picker_show_value_picker (SudokuNumberPicker* self,
                                             SudokuCell* cell);
VALA_EXTERN void sudoku_number_picker_show_earmark_picker (SudokuNumberPicker* self,
                                               SudokuCell* cell);
static void sudoku_view_set_cell_highlighter (SudokuView* self,
                                       gint row,
                                       gint col,
                                       gboolean enabled);
VALA_EXTERN void sudoku_cell_update_content_visibility (SudokuCell* self);
static void sudoku_view_update_value_highlighter (SudokuView* self,
                                           gint row,
                                           gint col,
                                           gint old_val,
                                           gint new_val);
VALA_EXTERN void sudoku_cell_update_earmark_visibility (SudokuCell* self,
                                            gint num);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_update_earmark_warnings (SudokuCell* self,
                                          gint num);
static void sudoku_view_clear_all_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_highlight_numbers (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_highlight_number (SudokuCell* self,
                                       gboolean value);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN gboolean sudoku_view_get_highlight_row_column (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_row (SudokuCell* self);
VALA_EXTERN gint sudoku_cell_get_col (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_highlight_block (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_highlight_coord (SudokuCell* self,
                                      gboolean value);
VALA_EXTERN void sudoku_cell_update_value_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_all_earmark_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_view_dismiss_picker (SudokuView* self);
static void sudoku_view_real_dispose (GObject* base);
VALA_EXTERN void sudoku_view_set_earmark_mode (SudokuView* self,
                                   gboolean value);
VALA_EXTERN gboolean sudoku_view_get_autoclean_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_autoclean_earmarks (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_number_picker_second_click (SudokuView* self);
VALA_EXTERN void sudoku_view_set_number_picker_second_click (SudokuView* self,
                                                 gboolean value);
VALA_EXTERN void sudoku_view_set_highlight_row_column (SudokuView* self,
                                           gboolean value);
VALA_EXTERN void sudoku_view_set_highlight_block (SudokuView* self,
                                      gboolean value);
VALA_EXTERN void sudoku_view_set_highlight_numbers (SudokuView* self,
                                        gboolean value);
VALA_EXTERN gdouble sudoku_view_get_value_zoom_multiplier (SudokuView* self);
static void sudoku_view_set_value_zoom_multiplier (SudokuView* self,
                                            gdouble value);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_earmark_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                            gboolean value);
VALA_EXTERN gboolean sudoku_view_get_solution_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_solution_warnings (SudokuView* self,
                                        gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
VALA_EXTERN gboolean sudoku_view_get_has_selection (SudokuView* self);
VALA_EXTERN ZoomLevel sudoku_view_get_zoom_level (SudokuView* self);
VALA_EXTERN void sudoku_view_set_zoom_level (SudokuView* self,
                                 ZoomLevel value);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
VALA_EXTERN gboolean zoom_level_is_fully_zoomed_out (ZoomLevel self);
VALA_EXTERN gboolean zoom_level_is_fully_zoomed_in (ZoomLevel self);
VALA_EXTERN ZoomLevel zoom_level_zoom_in (ZoomLevel self);
VALA_EXTERN ZoomLevel zoom_level_zoom_out (ZoomLevel self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_sudoku_view_value_changed_cb_sudoku_board_value_changed (SudokuBoard* _sender,
                                                          gint row,
                                                          gint col,
                                                          gint old_val,
                                                          gint new_val,
                                                          gpointer self)
{
	sudoku_view_value_changed_cb ((SudokuView*) self, row, col, old_val, new_val);
}

static void
_sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                              gint row,
                                                              gint col,
                                                              gint num,
                                                              gboolean enabled,
                                                              gpointer self)
{
	sudoku_view_earmark_changed_cb ((SudokuView*) self, row, col, num, enabled);
}

static void
_sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                 gint old_row,
                                                                 gint old_col,
                                                                 gint new_row,
                                                                 gint new_col,
                                                                 gpointer self)
{
	sudoku_view_selection_changed_cb ((SudokuView*) self, old_row, old_col, new_row, new_col);
}

static void
_sudoku_view_paused_cb_g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
	sudoku_view_paused_cb ((SudokuView*) self);
}

static gboolean
_sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_view_key_pressed_cb ((SudokuView*) self, keyval, keycode, state);
	return result;
}

static void
__lambda5_ (SudokuView* self)
{
	GtkWindow* window = NULL;
	GtkRoot* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
	window = _tmp1_;
	_tmp2_ = window;
	g_object_get (_tmp2_, "is-active", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		sudoku_view_set_has_selection (self, FALSE);
	}
	_g_object_unref0 (window);
}

static void
___lambda5__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                              gpointer self)
{
	__lambda5_ ((SudokuView*) self);
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game,
                       GSettings* settings)
{
	SudokuView * self = NULL;
	SudokuGame* _tmp0_;
	GSettings* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp4_;
	GtkOverlay* _tmp5_;
	SudokuFrame* _tmp6_;
	SudokuFrame* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkOverlay* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* _tmp12_;
	SudokuNumberPicker* _tmp13_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp14_ = NULL;
	GtkGrid* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkGrid* _tmp17_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp18_;
	SudokuBoard* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	SudokuBoard* _tmp22_;
	SudokuBoard* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GtkGrid** _tmp26_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp50_;
	SudokuBoard* _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	SudokuBoard* _tmp54_;
	SudokuBoard* _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
	SudokuCell** _tmp58_;
	SudokuGame* _tmp94_;
	SudokuBoard* _tmp95_;
	SudokuBoard* _tmp96_;
	SudokuGame* _tmp97_;
	SudokuBoard* _tmp98_;
	SudokuBoard* _tmp99_;
	GtkEventControllerKey* _tmp100_;
	GtkEventControllerKey* _tmp101_;
	GtkEventControllerKey* _tmp102_;
	GtkEventController* _tmp103_;
	GtkEventControllerFocus* _tmp104_;
	GtkEventControllerFocus* _tmp105_;
	GtkEventControllerFocus* _tmp106_;
	GtkEventController* _tmp107_;
	g_return_val_if_fail (game != NULL, NULL);
	g_return_val_if_fail (settings != NULL, NULL);
	self = (SudokuView*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (game);
	_g_object_unref0 (self->priv->game);
	self->priv->game = _tmp0_;
	_tmp1_ = _g_object_ref0 (settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp1_;
	_tmp2_ = sudoku_game_get_mode (game);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == GAME_MODE_CREATE) {
		self->priv->_show_warnings = TRUE;
	} else {
		g_settings_bind (settings, "show-warnings", (GObject*) self, "show-warnings", G_SETTINGS_BIND_GET);
	}
	g_settings_bind (settings, "solution-warnings", (GObject*) self, "solution-warnings", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "show-earmark-warnings", (GObject*) self, "show-earmark-warnings", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "autoclean-earmarks", (GObject*) self, "autoclean-earmarks", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "number-picker-second-click", (GObject*) self, "number-picker-second-click", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "highlighter", (GObject*) self, "highlighter", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "highlight-row-column", (GObject*) self, "highlight-row-column", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "highlight-block", (GObject*) self, "highlight-block", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "highlight-numbers", (GObject*) self, "highlight-numbers", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "zoom-level", (GObject*) self, "zoom-level", G_SETTINGS_BIND_GET);
	g_settings_bind (settings, "show-possibilities", (GObject*) self, "show-possibilities", G_SETTINGS_BIND_GET);
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
	_tmp4_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp4_);
	overlay = _tmp4_;
	_tmp5_ = overlay;
	_tmp6_ = sudoku_frame_new ((GtkWidget*) _tmp5_);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->frame);
	self->priv->frame = _tmp6_;
	_tmp7_ = self->priv->frame;
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp7_);
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Paused"));
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->paused_label);
	self->priv->paused_label = _tmp8_;
	_tmp9_ = self->priv->paused_label;
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
	_tmp10_ = overlay;
	_tmp11_ = self->priv->paused_label;
	gtk_overlay_add_overlay (_tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = overlay;
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "paused");
	_tmp13_ = sudoku_number_picker_new (game);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->number_picker);
	self->number_picker = _tmp13_;
	_tmp14_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_row_spacing (_tmp14_, 2);
	gtk_grid_set_column_spacing (_tmp14_, 2);
	gtk_grid_set_column_homogeneous (_tmp14_, TRUE);
	gtk_grid_set_row_homogeneous (_tmp14_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp14_, TRUE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
	g_object_ref_sink (_tmp14_);
	grid = _tmp14_;
	_tmp15_ = grid;
	gtk_widget_add_css_class ((GtkWidget*) _tmp15_, "board");
	_tmp16_ = overlay;
	_tmp17_ = grid;
	gtk_overlay_set_child (_tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = sudoku_game_get_board (game);
	_tmp19_ = _tmp18_;
	_tmp20_ = sudoku_board_get_block_rows (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = sudoku_game_get_board (game);
	_tmp23_ = _tmp22_;
	_tmp24_ = sudoku_board_get_block_cols (_tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = g_new0 (GtkGrid*, (_tmp21_ * _tmp25_) + 1);
	blocks = _tmp26_;
	blocks_length1 = _tmp21_;
	blocks_length2 = _tmp25_;
	{
		gint block_row = 0;
		block_row = 0;
		{
			gboolean _tmp27_ = FALSE;
			_tmp27_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp29_;
				SudokuBoard* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				if (!_tmp27_) {
					gint _tmp28_;
					_tmp28_ = block_row;
					block_row = _tmp28_ + 1;
				}
				_tmp27_ = FALSE;
				_tmp29_ = sudoku_game_get_board (game);
				_tmp30_ = _tmp29_;
				_tmp31_ = sudoku_board_get_block_rows (_tmp30_);
				_tmp32_ = _tmp31_;
				if (!(block_row < _tmp32_)) {
					break;
				}
				{
					gint block_col = 0;
					block_col = 0;
					{
						gboolean _tmp33_ = FALSE;
						_tmp33_ = TRUE;
						while (TRUE) {
							SudokuBoard* _tmp35_;
							SudokuBoard* _tmp36_;
							gint _tmp37_;
							gint _tmp38_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkGrid* _tmp45_;
							GtkGrid* _tmp46_;
							GtkGrid** _tmp47_;
							gint _tmp47__length1;
							gint _tmp47__length2;
							GtkGrid* _tmp48_;
							GtkGrid* _tmp49_;
							if (!_tmp33_) {
								gint _tmp34_;
								_tmp34_ = block_col;
								block_col = _tmp34_ + 1;
							}
							_tmp33_ = FALSE;
							_tmp35_ = sudoku_game_get_board (game);
							_tmp36_ = _tmp35_;
							_tmp37_ = sudoku_board_get_block_cols (_tmp36_);
							_tmp38_ = _tmp37_;
							if (!(block_col < _tmp38_)) {
								break;
							}
							_tmp39_ = (GtkGrid*) gtk_grid_new ();
							g_object_ref_sink (_tmp39_);
							block_grid = _tmp39_;
							_tmp40_ = block_grid;
							gtk_grid_set_row_spacing (_tmp40_, 1);
							_tmp41_ = block_grid;
							gtk_grid_set_column_spacing (_tmp41_, 1);
							_tmp42_ = block_grid;
							gtk_grid_set_column_homogeneous (_tmp42_, TRUE);
							_tmp43_ = block_grid;
							gtk_grid_set_row_homogeneous (_tmp43_, TRUE);
							_tmp44_ = block_grid;
							gtk_widget_add_css_class ((GtkWidget*) _tmp44_, "block");
							_tmp45_ = grid;
							_tmp46_ = block_grid;
							gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, block_col, block_row, 1, 1);
							_tmp47_ = blocks;
							_tmp47__length1 = blocks_length1;
							_tmp47__length2 = blocks_length2;
							_tmp48_ = block_grid;
							_tmp49_ = _g_object_ref0 (_tmp48_);
							_g_object_unref0 (_tmp47_[(block_row * _tmp47__length2) + block_col]);
							_tmp47_[(block_row * _tmp47__length2) + block_col] = _tmp49_;
							_g_object_unref0 (block_grid);
						}
					}
				}
			}
		}
	}
	_tmp50_ = sudoku_game_get_board (game);
	_tmp51_ = _tmp50_;
	_tmp52_ = sudoku_board_get_rows (_tmp51_);
	_tmp53_ = _tmp52_;
	_tmp54_ = sudoku_game_get_board (game);
	_tmp55_ = _tmp54_;
	_tmp56_ = sudoku_board_get_cols (_tmp55_);
	_tmp57_ = _tmp56_;
	_tmp58_ = g_new0 (SudokuCell*, (_tmp53_ * _tmp57_) + 1);
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->cells = _tmp58_;
	self->priv->cells_length1 = _tmp53_;
	self->priv->cells_length2 = _tmp57_;
	{
		gint row = 0;
		row = 0;
		{
			gboolean _tmp59_ = FALSE;
			_tmp59_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp61_;
				SudokuBoard* _tmp62_;
				gint _tmp63_;
				gint _tmp64_;
				if (!_tmp59_) {
					gint _tmp60_;
					_tmp60_ = row;
					row = _tmp60_ + 1;
				}
				_tmp59_ = FALSE;
				_tmp61_ = sudoku_game_get_board (game);
				_tmp62_ = _tmp61_;
				_tmp63_ = sudoku_board_get_rows (_tmp62_);
				_tmp64_ = _tmp63_;
				if (!(row < _tmp64_)) {
					break;
				}
				{
					gint col = 0;
					col = 0;
					{
						gboolean _tmp65_ = FALSE;
						_tmp65_ = TRUE;
						while (TRUE) {
							SudokuBoard* _tmp67_;
							SudokuBoard* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							SudokuCell* cell = NULL;
							SudokuCell* _tmp71_;
							GtkGrid** _tmp72_;
							gint _tmp72__length1;
							gint _tmp72__length2;
							SudokuBoard* _tmp73_;
							SudokuBoard* _tmp74_;
							gint _tmp75_;
							gint _tmp76_;
							SudokuBoard* _tmp77_;
							SudokuBoard* _tmp78_;
							gint _tmp79_;
							gint _tmp80_;
							GtkGrid* _tmp81_;
							SudokuCell* _tmp82_;
							SudokuBoard* _tmp83_;
							SudokuBoard* _tmp84_;
							gint _tmp85_;
							gint _tmp86_;
							SudokuBoard* _tmp87_;
							SudokuBoard* _tmp88_;
							gint _tmp89_;
							gint _tmp90_;
							SudokuCell** _tmp91_;
							gint _tmp91__length1;
							gint _tmp91__length2;
							SudokuCell* _tmp92_;
							SudokuCell* _tmp93_;
							if (!_tmp65_) {
								gint _tmp66_;
								_tmp66_ = col;
								col = _tmp66_ + 1;
							}
							_tmp65_ = FALSE;
							_tmp67_ = sudoku_game_get_board (game);
							_tmp68_ = _tmp67_;
							_tmp69_ = sudoku_board_get_cols (_tmp68_);
							_tmp70_ = _tmp69_;
							if (!(col < _tmp70_)) {
								break;
							}
							_tmp71_ = sudoku_cell_new (row, col, game, self);
							g_object_ref_sink (_tmp71_);
							cell = _tmp71_;
							_tmp72_ = blocks;
							_tmp72__length1 = blocks_length1;
							_tmp72__length2 = blocks_length2;
							_tmp73_ = sudoku_game_get_board (game);
							_tmp74_ = _tmp73_;
							_tmp75_ = sudoku_board_get_block_rows (_tmp74_);
							_tmp76_ = _tmp75_;
							_tmp77_ = sudoku_game_get_board (game);
							_tmp78_ = _tmp77_;
							_tmp79_ = sudoku_board_get_block_cols (_tmp78_);
							_tmp80_ = _tmp79_;
							_tmp81_ = _tmp72_[((row / _tmp76_) * _tmp72__length2) + (col / _tmp80_)];
							_tmp82_ = cell;
							_tmp83_ = sudoku_game_get_board (game);
							_tmp84_ = _tmp83_;
							_tmp85_ = sudoku_board_get_block_cols (_tmp84_);
							_tmp86_ = _tmp85_;
							_tmp87_ = sudoku_game_get_board (game);
							_tmp88_ = _tmp87_;
							_tmp89_ = sudoku_board_get_block_rows (_tmp88_);
							_tmp90_ = _tmp89_;
							gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, col % _tmp86_, row % _tmp90_, 1, 1);
							_tmp91_ = self->priv->cells;
							_tmp91__length1 = self->priv->cells_length1;
							_tmp91__length2 = self->priv->cells_length2;
							_tmp92_ = cell;
							_tmp93_ = _g_object_ref0 (_tmp92_);
							_g_object_unref0 (_tmp91_[(row * _tmp91__length2) + col]);
							_tmp91_[(row * _tmp91__length2) + col] = _tmp93_;
							_g_object_unref0 (cell);
						}
					}
				}
			}
		}
	}
	_tmp94_ = self->priv->game;
	_tmp95_ = sudoku_game_get_board (_tmp94_);
	_tmp96_ = _tmp95_;
	g_signal_connect_object (_tmp96_, "value-changed", (GCallback) _sudoku_view_value_changed_cb_sudoku_board_value_changed, self, 0);
	_tmp97_ = self->priv->game;
	_tmp98_ = sudoku_game_get_board (_tmp97_);
	_tmp99_ = _tmp98_;
	g_signal_connect_object (_tmp99_, "earmark-changed", (GCallback) _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed, self, 0);
	g_signal_connect_object (self, "selection-changed", (GCallback) _sudoku_view_selection_changed_cb_sudoku_view_selection_changed, self, 0);
	g_signal_connect_object ((GObject*) game, "notify::paused", (GCallback) _sudoku_view_paused_cb_g_object_notify, self, 0);
	_tmp100_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
	_g_object_unref0 (self->priv->key_controller);
	self->priv->key_controller = _tmp100_;
	_tmp101_ = self->priv->key_controller;
	g_signal_connect_object (_tmp101_, "key-pressed", (GCallback) _sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
	_tmp102_ = self->priv->key_controller;
	_tmp103_ = _g_object_ref0 ((GtkEventController*) _tmp102_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp103_);
	_tmp104_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
	_g_object_unref0 (self->priv->focus_controller);
	self->priv->focus_controller = _tmp104_;
	_tmp105_ = self->priv->focus_controller;
	g_signal_connect_object (_tmp105_, "leave", (GCallback) ___lambda5__gtk_event_controller_focus_leave, self, 0);
	_tmp106_ = self->priv->focus_controller;
	_tmp107_ = _g_object_ref0 ((GtkEventController*) _tmp106_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp107_);
	sudoku_view_update_warnings (self);
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (grid);
	_g_object_unref0 (overlay);
	return self;
}

SudokuView*
sudoku_view_new (SudokuGame* game,
                 GSettings* settings)
{
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game, settings);
}

static gboolean
sudoku_view_key_pressed_cb (SudokuView* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean control_pressed = FALSE;
	SudokuCell* _tmp35_;
	SudokuCell* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		result = GDK_EVENT_PROPAGATE;
		return result;
	}
	control_pressed = (gboolean) (state & GDK_CONTROL_MASK);
	if (!control_pressed) {
		switch (keyval) {
			case GDK_KEY_Up:
			case GDK_KEY_w:
			case GDK_KEY_KP_Up:
			{
				gint _tmp3_;
				_tmp3_ = self->priv->_selected_row;
				if (_tmp3_ == 0) {
					SudokuCell** _tmp4_;
					gint _tmp4__length1;
					gint _tmp4__length2;
					gint _tmp5_;
					SudokuCell* _tmp6_;
					_tmp4_ = self->priv->cells;
					_tmp4__length1 = self->priv->cells_length1;
					_tmp4__length2 = self->priv->cells_length2;
					_tmp5_ = self->priv->_selected_col;
					_tmp6_ = _tmp4_[(8 * _tmp4__length2) + _tmp5_];
					gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
				} else {
					SudokuCell** _tmp7_;
					gint _tmp7__length1;
					gint _tmp7__length2;
					gint _tmp8_;
					gint _tmp9_;
					SudokuCell* _tmp10_;
					_tmp7_ = self->priv->cells;
					_tmp7__length1 = self->priv->cells_length1;
					_tmp7__length2 = self->priv->cells_length2;
					_tmp8_ = self->priv->_selected_row;
					_tmp9_ = self->priv->_selected_col;
					_tmp10_ = _tmp7_[((_tmp8_ - 1) * _tmp7__length2) + _tmp9_];
					gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
				}
				result = GDK_EVENT_STOP;
				return result;
			}
			case GDK_KEY_Down:
			case GDK_KEY_s:
			case GDK_KEY_KP_Down:
			{
				gint _tmp11_;
				_tmp11_ = self->priv->_selected_row;
				if (_tmp11_ == 8) {
					SudokuCell** _tmp12_;
					gint _tmp12__length1;
					gint _tmp12__length2;
					gint _tmp13_;
					SudokuCell* _tmp14_;
					_tmp12_ = self->priv->cells;
					_tmp12__length1 = self->priv->cells_length1;
					_tmp12__length2 = self->priv->cells_length2;
					_tmp13_ = self->priv->_selected_col;
					_tmp14_ = _tmp12_[(0 * _tmp12__length2) + _tmp13_];
					gtk_widget_grab_focus ((GtkWidget*) _tmp14_);
				} else {
					SudokuCell** _tmp15_;
					gint _tmp15__length1;
					gint _tmp15__length2;
					gint _tmp16_;
					gint _tmp17_;
					SudokuCell* _tmp18_;
					_tmp15_ = self->priv->cells;
					_tmp15__length1 = self->priv->cells_length1;
					_tmp15__length2 = self->priv->cells_length2;
					_tmp16_ = self->priv->_selected_row;
					_tmp17_ = self->priv->_selected_col;
					_tmp18_ = _tmp15_[((_tmp16_ + 1) * _tmp15__length2) + _tmp17_];
					gtk_widget_grab_focus ((GtkWidget*) _tmp18_);
				}
				result = GDK_EVENT_STOP;
				return result;
			}
			case GDK_KEY_Left:
			case GDK_KEY_a:
			case GDK_KEY_KP_Left:
			{
				gint _tmp19_;
				_tmp19_ = self->priv->_selected_col;
				if (_tmp19_ == 0) {
					SudokuCell** _tmp20_;
					gint _tmp20__length1;
					gint _tmp20__length2;
					gint _tmp21_;
					SudokuCell* _tmp22_;
					_tmp20_ = self->priv->cells;
					_tmp20__length1 = self->priv->cells_length1;
					_tmp20__length2 = self->priv->cells_length2;
					_tmp21_ = self->priv->_selected_row;
					_tmp22_ = _tmp20_[(_tmp21_ * _tmp20__length2) + 8];
					gtk_widget_grab_focus ((GtkWidget*) _tmp22_);
				} else {
					SudokuCell** _tmp23_;
					gint _tmp23__length1;
					gint _tmp23__length2;
					gint _tmp24_;
					gint _tmp25_;
					SudokuCell* _tmp26_;
					_tmp23_ = self->priv->cells;
					_tmp23__length1 = self->priv->cells_length1;
					_tmp23__length2 = self->priv->cells_length2;
					_tmp24_ = self->priv->_selected_row;
					_tmp25_ = self->priv->_selected_col;
					_tmp26_ = _tmp23_[(_tmp24_ * _tmp23__length2) + (_tmp25_ - 1)];
					gtk_widget_grab_focus ((GtkWidget*) _tmp26_);
				}
				result = GDK_EVENT_STOP;
				return result;
			}
			case GDK_KEY_Right:
			case GDK_KEY_d:
			case GDK_KEY_KP_Right:
			{
				gint _tmp27_;
				_tmp27_ = self->priv->_selected_col;
				if (_tmp27_ == 8) {
					SudokuCell** _tmp28_;
					gint _tmp28__length1;
					gint _tmp28__length2;
					gint _tmp29_;
					SudokuCell* _tmp30_;
					_tmp28_ = self->priv->cells;
					_tmp28__length1 = self->priv->cells_length1;
					_tmp28__length2 = self->priv->cells_length2;
					_tmp29_ = self->priv->_selected_row;
					_tmp30_ = _tmp28_[(_tmp29_ * _tmp28__length2) + 0];
					gtk_widget_grab_focus ((GtkWidget*) _tmp30_);
				} else {
					SudokuCell** _tmp31_;
					gint _tmp31__length1;
					gint _tmp31__length2;
					gint _tmp32_;
					gint _tmp33_;
					SudokuCell* _tmp34_;
					_tmp31_ = self->priv->cells;
					_tmp31__length1 = self->priv->cells_length1;
					_tmp31__length2 = self->priv->cells_length2;
					_tmp32_ = self->priv->_selected_row;
					_tmp33_ = self->priv->_selected_col;
					_tmp34_ = _tmp31_[(_tmp32_ * _tmp31__length2) + (_tmp33_ + 1)];
					gtk_widget_grab_focus ((GtkWidget*) _tmp34_);
				}
				result = GDK_EVENT_STOP;
				return result;
			}
			default:
			{
				break;
			}
		}
	}
	_tmp35_ = sudoku_view_get_selected_cell (self);
	_tmp36_ = _tmp35_;
	_tmp37_ = sudoku_cell_get_is_fixed (_tmp36_);
	_tmp38_ = _tmp37_;
	if (_tmp38_) {
		result = GDK_EVENT_PROPAGATE;
		return result;
	}
	switch (keyval) {
		case GDK_KEY_0:
		case GDK_KEY_KP_0:
		case GDK_KEY_BackSpace:
		case GDK_KEY_Delete:
		{
			if (control_pressed) {
				result = GDK_EVENT_PROPAGATE;
				return result;
			} else {
				SudokuCell* _tmp39_;
				SudokuCell* _tmp40_;
				_tmp39_ = sudoku_view_get_selected_cell (self);
				_tmp40_ = _tmp39_;
				sudoku_cell_set_value (_tmp40_, 0);
				result = GDK_EVENT_STOP;
				return result;
			}
		}
		case GDK_KEY_1:
		case GDK_KEY_KP_1:
		{
			sudoku_view_insert_key (self, 1, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_2:
		case GDK_KEY_KP_2:
		{
			sudoku_view_insert_key (self, 2, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_3:
		case GDK_KEY_KP_3:
		{
			sudoku_view_insert_key (self, 3, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_4:
		case GDK_KEY_KP_4:
		{
			sudoku_view_insert_key (self, 4, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_5:
		case GDK_KEY_KP_5:
		{
			sudoku_view_insert_key (self, 5, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_6:
		case GDK_KEY_KP_6:
		{
			sudoku_view_insert_key (self, 6, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_7:
		case GDK_KEY_KP_7:
		{
			sudoku_view_insert_key (self, 7, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_8:
		case GDK_KEY_KP_8:
		{
			sudoku_view_insert_key (self, 8, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_9:
		case GDK_KEY_KP_9:
		{
			sudoku_view_insert_key (self, 9, control_pressed);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_Escape:
		{
			SudokuNumberPicker* _tmp41_;
			_tmp41_ = self->number_picker;
			gtk_popover_popdown ((GtkPopover*) _tmp41_);
			result = GDK_EVENT_STOP;
			return result;
		}
		case GDK_KEY_space:
		case GDK_KEY_Return:
		case GDK_KEY_KP_Enter:
		{
			SudokuCell* _tmp42_;
			SudokuCell* _tmp43_;
			gboolean wants_value = FALSE;
			gboolean _tmp44_;
			_tmp42_ = sudoku_view_get_selected_cell (self);
			_tmp43_ = _tmp42_;
			gtk_widget_grab_focus ((GtkWidget*) _tmp43_);
			wants_value = !control_pressed;
			_tmp44_ = self->priv->_earmark_mode;
			wants_value = wants_value ^ _tmp44_;
			if (wants_value) {
				SudokuNumberPicker* _tmp45_;
				SudokuCell* _tmp46_;
				SudokuCell* _tmp47_;
				_tmp45_ = self->number_picker;
				_tmp46_ = sudoku_view_get_selected_cell (self);
				_tmp47_ = _tmp46_;
				sudoku_number_picker_show_value_picker (_tmp45_, _tmp47_);
			} else {
				SudokuNumberPicker* _tmp48_;
				SudokuCell* _tmp49_;
				SudokuCell* _tmp50_;
				_tmp48_ = self->number_picker;
				_tmp49_ = sudoku_view_get_selected_cell (self);
				_tmp50_ = _tmp49_;
				sudoku_number_picker_show_earmark_picker (_tmp48_, _tmp50_);
			}
			result = GDK_EVENT_STOP;
			return result;
		}
		default:
		{
			result = GDK_EVENT_PROPAGATE;
			return result;
		}
	}
}

static void
sudoku_view_selection_changed_cb (SudokuView* self,
                                  gint old_row,
                                  gint old_col,
                                  gint new_row,
                                  gint new_col)
{
	SudokuNumberPicker* _tmp0_;
	g_return_if_fail (self != NULL);
	sudoku_view_set_cell_highlighter (self, old_row, old_col, FALSE);
	sudoku_view_set_cell_highlighter (self, new_row, new_col, TRUE);
	_tmp0_ = self->number_picker;
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
}

static void
sudoku_view_value_changed_cb (SudokuView* self,
                              gint row,
                              gint col,
                              gint old_val,
                              gint new_val)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	SudokuCell* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	action = sudoku_game_get_current_stack_action (_tmp0_);
	if (stack_action_is_single_value_change (action)) {
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
		_tmp1_ = self->priv->cells;
		_tmp1__length1 = self->priv->cells_length1;
		_tmp1__length2 = self->priv->cells_length2;
		_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
	}
	_tmp3_ = self->priv->cells;
	_tmp3__length1 = self->priv->cells_length1;
	_tmp3__length2 = self->priv->cells_length2;
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
	sudoku_cell_update_content_visibility (_tmp4_);
	sudoku_view_update_warnings (self);
	sudoku_view_update_value_highlighter (self, row, col, old_val, new_val);
}

static void
sudoku_view_earmark_changed_cb (SudokuView* self,
                                gint row,
                                gint col,
                                gint num,
                                gboolean enabled)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	SudokuCell* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	action = sudoku_game_get_current_stack_action (_tmp0_);
	if (stack_action_is_single_earmarks_change (action)) {
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
		_tmp1_ = self->priv->cells;
		_tmp1__length1 = self->priv->cells_length1;
		_tmp1__length2 = self->priv->cells_length2;
		_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
	}
	_tmp3_ = self->priv->cells;
	_tmp3__length1 = self->priv->cells_length1;
	_tmp3__length2 = self->priv->cells_length2;
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
	sudoku_cell_update_earmark_visibility (_tmp4_, num);
	_tmp5_ = sudoku_view_get_show_warnings (self);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		SudokuCell** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		SudokuCell* _tmp8_;
		_tmp7_ = self->priv->cells;
		_tmp7__length1 = self->priv->cells_length1;
		_tmp7__length2 = self->priv->cells_length2;
		_tmp8_ = _tmp7_[(row * _tmp7__length2) + col];
		sudoku_cell_update_earmark_warnings (_tmp8_, num);
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
	return self ? pango_attr_list_ref (self) : NULL;
}

static void
sudoku_view_paused_cb (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	GtkLabel* _tmp9_;
	SudokuGame* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	SudokuGame* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	SudokuGame* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	SudokuGame* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->paused_label;
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
	attr_list = _tmp2_;
	_tmp3_ = attr_list;
	if (_tmp3_ == NULL) {
		PangoAttrList* _tmp4_;
		_tmp4_ = pango_attr_list_new ();
		_pango_attr_list_unref0 (attr_list);
		attr_list = _tmp4_;
	}
	_tmp5_ = attr_list;
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
	pango_attr_list_change (_tmp5_, _tmp6_);
	_tmp7_ = self->priv->paused_label;
	_tmp8_ = attr_list;
	gtk_label_set_attributes (_tmp7_, _tmp8_);
	_tmp9_ = self->priv->paused_label;
	_tmp10_ = self->priv->game;
	_tmp11_ = sudoku_game_get_paused (_tmp10_);
	_tmp12_ = _tmp11_;
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, _tmp12_);
	_tmp13_ = self->priv->game;
	_tmp14_ = sudoku_game_get_paused (_tmp13_);
	_tmp15_ = _tmp14_;
	gtk_widget_set_can_focus ((GtkWidget*) self, !_tmp15_);
	_tmp16_ = self->priv->game;
	_tmp17_ = sudoku_game_get_paused (_tmp16_);
	_tmp18_ = _tmp17_;
	sudoku_view_set_has_selection (self, !_tmp18_);
	_tmp19_ = self->priv->game;
	_tmp20_ = sudoku_game_get_paused (_tmp19_);
	_tmp21_ = _tmp20_;
	if (_tmp21_) {
		sudoku_view_clear_all_warnings (self);
	} else {
		sudoku_view_update_warnings (self);
	}
	_pango_attr_list_unref0 (attr_list);
}

void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gint old_row = 0;
	gint _tmp6_;
	gint old_col = 0;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	SudokuCell* _tmp10_;
	SudokuCell* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cells;
	_tmp0__length1 = self->priv->cells_length1;
	_tmp0__length2 = self->priv->cells_length2;
	_tmp1_ = _tmp0_[(cell_row * _tmp0__length2) + cell_col];
	_tmp2_ = sudoku_cell_get_selected (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == TRUE) {
		return;
	}
	_tmp4_ = sudoku_view_get_selected_cell (self);
	_tmp5_ = _tmp4_;
	sudoku_cell_set_selected (_tmp5_, FALSE);
	_tmp6_ = self->priv->_selected_row;
	old_row = _tmp6_;
	_tmp7_ = self->priv->_selected_col;
	old_col = _tmp7_;
	sudoku_view_set_selected_row (self, cell_row);
	sudoku_view_set_selected_col (self, cell_col);
	_tmp8_ = self->priv->_selected_row;
	_tmp9_ = self->priv->_selected_col;
	g_signal_emit (self, sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL], 0, old_row, old_col, _tmp8_, _tmp9_);
	_tmp10_ = sudoku_view_get_selected_cell (self);
	_tmp11_ = _tmp10_;
	sudoku_cell_set_selected (_tmp11_, TRUE);
}

static void
sudoku_view_set_cell_highlighter (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell** _tmp2_ = NULL;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCell* _tmp4_ = NULL;
	SudokuCell* target_cell = NULL;
	SudokuCell* _tmp6_;
	SudokuCell** _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_view_get_highlighter (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp3_ = self->priv->cells;
	_tmp3__length1 = self->priv->cells_length1;
	_tmp3__length2 = self->priv->cells_length2;
	_tmp2_ = _tmp3_;
	_tmp2__length1 = _tmp3__length1;
	_tmp2__length2 = _tmp3__length2;
	_tmp4_ = NULL;
	if (_tmp2_ != NULL) {
		SudokuCell* _tmp5_;
		_tmp5_ = _tmp2_[(row * _tmp2__length2) + col];
		_tmp4_ = _tmp5_;
	}
	_tmp6_ = _g_object_ref0 (_tmp4_);
	target_cell = _tmp6_;
	_tmp7_ = self->priv->cells;
	_tmp7__length1 = self->priv->cells_length1;
	_tmp7__length2 = self->priv->cells_length2;
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
		cell_collection = _tmp7_;
		cell_collection_length1 = _tmp7__length1 * _tmp7__length2;
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
			SudokuCell* _tmp8_;
			SudokuCell* cell = NULL;
			_tmp8_ = _g_object_ref0 (cell_collection[cell_it]);
			cell = _tmp8_;
			{
				SudokuCell* _tmp9_;
				SudokuCell* _tmp10_;
				gboolean _tmp11_ = FALSE;
				SudokuCell* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gboolean _tmp30_ = FALSE;
				SudokuCell* _tmp31_;
				gboolean _tmp32_;
				gboolean _tmp33_;
				_tmp9_ = cell;
				_tmp10_ = target_cell;
				if (_tmp9_ == _tmp10_) {
					_g_object_unref0 (cell);
					continue;
				}
				_tmp12_ = target_cell;
				_tmp13_ = sudoku_cell_get_value (_tmp12_);
				_tmp14_ = _tmp13_;
				if (_tmp14_ > 0) {
					gboolean _tmp15_;
					_tmp15_ = self->priv->_highlight_numbers;
					_tmp11_ = _tmp15_;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					SudokuCell* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					SudokuCell* _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					_tmp16_ = target_cell;
					_tmp17_ = sudoku_cell_get_value (_tmp16_);
					_tmp18_ = _tmp17_;
					_tmp19_ = cell;
					_tmp20_ = sudoku_cell_get_value (_tmp19_);
					_tmp21_ = _tmp20_;
					if (_tmp18_ == _tmp21_) {
						SudokuCell* _tmp22_;
						_tmp22_ = cell;
						sudoku_cell_set_highlight_number (_tmp22_, enabled);
					} else {
						SudokuCell* _tmp23_;
						gint _tmp24_;
						gint _tmp25_;
						_tmp23_ = cell;
						_tmp24_ = sudoku_cell_get_value (_tmp23_);
						_tmp25_ = _tmp24_;
						if (_tmp25_ == 0) {
							SudokuCell* _tmp26_;
							SudokuCell* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							_tmp26_ = cell;
							_tmp27_ = target_cell;
							_tmp28_ = sudoku_cell_get_value (_tmp27_);
							_tmp29_ = _tmp28_;
							sudoku_cell_set_earmark_highlight (_tmp26_, _tmp29_, enabled);
						}
					}
				}
				_tmp31_ = cell;
				_tmp32_ = sudoku_cell_get_is_fixed (_tmp31_);
				_tmp33_ = _tmp32_;
				if (!_tmp33_) {
					gboolean _tmp34_ = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_;
					_tmp36_ = self->priv->_highlight_row_column;
					if (_tmp36_) {
						gboolean _tmp37_ = FALSE;
						SudokuCell* _tmp38_;
						gint _tmp39_;
						gint _tmp40_;
						_tmp38_ = cell;
						_tmp39_ = sudoku_cell_get_row (_tmp38_);
						_tmp40_ = _tmp39_;
						if (_tmp40_ == row) {
							_tmp37_ = TRUE;
						} else {
							SudokuCell* _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
							_tmp41_ = cell;
							_tmp42_ = sudoku_cell_get_col (_tmp41_);
							_tmp43_ = _tmp42_;
							_tmp37_ = _tmp43_ == col;
						}
						_tmp35_ = _tmp37_;
					} else {
						_tmp35_ = FALSE;
					}
					if (_tmp35_) {
						_tmp34_ = TRUE;
					} else {
						gboolean _tmp44_ = FALSE;
						gboolean _tmp45_ = FALSE;
						gboolean _tmp46_;
						_tmp46_ = self->priv->_highlight_block;
						if (_tmp46_) {
							SudokuCell* _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							SudokuGame* _tmp50_;
							SudokuBoard* _tmp51_;
							SudokuBoard* _tmp52_;
							gint _tmp53_;
							gint _tmp54_;
							SudokuGame* _tmp55_;
							SudokuBoard* _tmp56_;
							SudokuBoard* _tmp57_;
							gint _tmp58_;
							gint _tmp59_;
							_tmp47_ = cell;
							_tmp48_ = sudoku_cell_get_row (_tmp47_);
							_tmp49_ = _tmp48_;
							_tmp50_ = self->priv->game;
							_tmp51_ = sudoku_game_get_board (_tmp50_);
							_tmp52_ = _tmp51_;
							_tmp53_ = sudoku_board_get_block_cols (_tmp52_);
							_tmp54_ = _tmp53_;
							_tmp55_ = self->priv->game;
							_tmp56_ = sudoku_game_get_board (_tmp55_);
							_tmp57_ = _tmp56_;
							_tmp58_ = sudoku_board_get_block_cols (_tmp57_);
							_tmp59_ = _tmp58_;
							_tmp45_ = (_tmp49_ / _tmp54_) == (row / _tmp59_);
						} else {
							_tmp45_ = FALSE;
						}
						if (_tmp45_) {
							SudokuCell* _tmp60_;
							gint _tmp61_;
							gint _tmp62_;
							SudokuGame* _tmp63_;
							SudokuBoard* _tmp64_;
							SudokuBoard* _tmp65_;
							gint _tmp66_;
							gint _tmp67_;
							SudokuGame* _tmp68_;
							SudokuBoard* _tmp69_;
							SudokuBoard* _tmp70_;
							gint _tmp71_;
							gint _tmp72_;
							_tmp60_ = cell;
							_tmp61_ = sudoku_cell_get_col (_tmp60_);
							_tmp62_ = _tmp61_;
							_tmp63_ = self->priv->game;
							_tmp64_ = sudoku_game_get_board (_tmp63_);
							_tmp65_ = _tmp64_;
							_tmp66_ = sudoku_board_get_block_rows (_tmp65_);
							_tmp67_ = _tmp66_;
							_tmp68_ = self->priv->game;
							_tmp69_ = sudoku_game_get_board (_tmp68_);
							_tmp70_ = _tmp69_;
							_tmp71_ = sudoku_board_get_block_rows (_tmp70_);
							_tmp72_ = _tmp71_;
							_tmp44_ = (_tmp62_ / _tmp67_) == (col / _tmp72_);
						} else {
							_tmp44_ = FALSE;
						}
						_tmp34_ = _tmp44_;
					}
					_tmp30_ = _tmp34_;
				} else {
					_tmp30_ = FALSE;
				}
				if (_tmp30_) {
					SudokuCell* _tmp73_;
					_tmp73_ = cell;
					sudoku_cell_set_highlight_coord (_tmp73_, enabled);
				}
				_g_object_unref0 (cell);
			}
		}
	}
	_g_object_unref0 (target_cell);
}

static void
sudoku_view_update_value_highlighter (SudokuView* self,
                                      gint row,
                                      gint col,
                                      gint old_val,
                                      gint new_val)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp1_ = sudoku_view_get_highlighter (self);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp3_;
		_tmp3_ = self->priv->_highlight_numbers;
		_tmp0_ = !_tmp3_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp5_ = self->priv->_selected_row;
	if (row != _tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gint _tmp6_;
		_tmp6_ = self->priv->_selected_col;
		_tmp4_ = col != _tmp6_;
	}
	if (_tmp4_) {
		SudokuCell* _tmp7_;
		SudokuCell* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp7_ = sudoku_view_get_selected_cell (self);
		_tmp8_ = _tmp7_;
		_tmp9_ = sudoku_cell_get_value (_tmp8_);
		_tmp10_ = _tmp9_;
		if (old_val == _tmp10_) {
			SudokuCell** _tmp11_;
			gint _tmp11__length1;
			gint _tmp11__length2;
			SudokuCell* _tmp12_;
			_tmp11_ = self->priv->cells;
			_tmp11__length1 = self->priv->cells_length1;
			_tmp11__length2 = self->priv->cells_length2;
			_tmp12_ = _tmp11_[(row * _tmp11__length2) + col];
			sudoku_cell_set_highlight_number (_tmp12_, FALSE);
		} else {
			gboolean _tmp13_ = FALSE;
			SudokuCell* _tmp14_;
			SudokuCell* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			_tmp14_ = sudoku_view_get_selected_cell (self);
			_tmp15_ = _tmp14_;
			_tmp16_ = sudoku_cell_get_value (_tmp15_);
			_tmp17_ = _tmp16_;
			if (new_val == _tmp17_) {
				_tmp13_ = new_val != 0;
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				SudokuCell** _tmp18_;
				gint _tmp18__length1;
				gint _tmp18__length2;
				SudokuCell* _tmp19_;
				_tmp18_ = self->priv->cells;
				_tmp18__length1 = self->priv->cells_length1;
				_tmp18__length2 = self->priv->cells_length2;
				_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
				sudoku_cell_set_highlight_number (_tmp19_, TRUE);
			}
		}
		return;
	}
	{
		gint col_tmp = 0;
		col_tmp = 0;
		{
			gboolean _tmp20_ = FALSE;
			_tmp20_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp22_;
				SudokuBoard* _tmp23_;
				SudokuBoard* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				if (!_tmp20_) {
					gint _tmp21_;
					_tmp21_ = col_tmp;
					col_tmp = _tmp21_ + 1;
				}
				_tmp20_ = FALSE;
				_tmp22_ = self->priv->game;
				_tmp23_ = sudoku_game_get_board (_tmp22_);
				_tmp24_ = _tmp23_;
				_tmp25_ = sudoku_board_get_cols (_tmp24_);
				_tmp26_ = _tmp25_;
				if (!(col_tmp < _tmp26_)) {
					break;
				}
				{
					gint row_tmp = 0;
					row_tmp = 0;
					{
						gboolean _tmp27_ = FALSE;
						_tmp27_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp29_;
							SudokuBoard* _tmp30_;
							SudokuBoard* _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp34_;
							gint _tmp34__length1;
							gint _tmp34__length2;
							SudokuCell* _tmp35_;
							SudokuCell* _tmp36_;
							SudokuCell* _tmp37_;
							SudokuCell* _tmp38_;
							SudokuCell* _tmp39_;
							SudokuCell* _tmp40_;
							gint _tmp41_;
							gint _tmp42_;
							if (!_tmp27_) {
								gint _tmp28_;
								_tmp28_ = row_tmp;
								row_tmp = _tmp28_ + 1;
							}
							_tmp27_ = FALSE;
							_tmp29_ = self->priv->game;
							_tmp30_ = sudoku_game_get_board (_tmp29_);
							_tmp31_ = _tmp30_;
							_tmp32_ = sudoku_board_get_rows (_tmp31_);
							_tmp33_ = _tmp32_;
							if (!(row_tmp < _tmp33_)) {
								break;
							}
							_tmp34_ = self->priv->cells;
							_tmp34__length1 = self->priv->cells_length1;
							_tmp34__length2 = self->priv->cells_length2;
							_tmp35_ = _tmp34_[(row_tmp * _tmp34__length2) + col_tmp];
							_tmp36_ = _g_object_ref0 (_tmp35_);
							cell_tmp = _tmp36_;
							_tmp37_ = sudoku_view_get_selected_cell (self);
							_tmp38_ = _tmp37_;
							_tmp39_ = cell_tmp;
							if (_tmp38_ == _tmp39_) {
								_g_object_unref0 (cell_tmp);
								continue;
							}
							_tmp40_ = cell_tmp;
							_tmp41_ = sudoku_cell_get_value (_tmp40_);
							_tmp42_ = _tmp41_;
							if (_tmp42_ == 0) {
								if (old_val > 0) {
									SudokuCell* _tmp43_;
									_tmp43_ = cell_tmp;
									sudoku_cell_set_earmark_highlight (_tmp43_, old_val, FALSE);
								}
								if (new_val > 0) {
									SudokuCell* _tmp44_;
									_tmp44_ = cell_tmp;
									sudoku_cell_set_earmark_highlight (_tmp44_, new_val, TRUE);
								}
							} else {
								SudokuCell* _tmp45_;
								gint _tmp46_;
								gint _tmp47_;
								_tmp45_ = cell_tmp;
								_tmp46_ = sudoku_cell_get_value (_tmp45_);
								_tmp47_ = _tmp46_;
								if (new_val == _tmp47_) {
									SudokuCell* _tmp48_;
									_tmp48_ = cell_tmp;
									sudoku_cell_set_highlight_number (_tmp48_, TRUE);
								} else {
									SudokuCell* _tmp49_;
									gint _tmp50_;
									gint _tmp51_;
									_tmp49_ = cell_tmp;
									_tmp50_ = sudoku_cell_get_value (_tmp49_);
									_tmp51_ = _tmp50_;
									if (old_val == _tmp51_) {
										SudokuCell* _tmp52_;
										_tmp52_ = cell_tmp;
										sudoku_cell_set_highlight_number (_tmp52_, FALSE);
									}
								}
							}
							_g_object_unref0 (cell_tmp);
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_update_warnings (SudokuView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_view_get_show_warnings (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->cells;
	_tmp2__length1 = self->priv->cells_length1;
	_tmp2__length2 = self->priv->cells_length2;
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
		cell_collection = _tmp2_;
		cell_collection_length1 = _tmp2__length1 * _tmp2__length2;
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
			SudokuCell* _tmp3_;
			SudokuCell* cell = NULL;
			_tmp3_ = _g_object_ref0 (cell_collection[cell_it]);
			cell = _tmp3_;
			{
				SudokuCell* _tmp4_;
				SudokuCell* _tmp5_;
				_tmp4_ = cell;
				sudoku_cell_update_value_warnings (_tmp4_);
				_tmp5_ = cell;
				sudoku_cell_update_all_earmark_warnings (_tmp5_);
				_g_object_unref0 (cell);
			}
		}
	}
}

static void
sudoku_view_clear_all_warnings (SudokuView* self)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cells;
	_tmp0__length1 = self->priv->cells_length1;
	_tmp0__length2 = self->priv->cells_length2;
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
		cell_collection = _tmp0_;
		cell_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
			SudokuCell* _tmp1_;
			SudokuCell* cell = NULL;
			_tmp1_ = _g_object_ref0 (cell_collection[cell_it]);
			cell = _tmp1_;
			{
				SudokuCell* _tmp2_;
				_tmp2_ = cell;
				sudoku_cell_clear_warnings (_tmp2_);
				_g_object_unref0 (cell);
			}
		}
	}
}

static void
sudoku_view_insert_key (SudokuView* self,
                        gint key,
                        gboolean control_pressed)
{
	SudokuNumberPicker* _tmp0_;
	gboolean wants_value = FALSE;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->number_picker;
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
	wants_value = !control_pressed;
	_tmp1_ = self->priv->_earmark_mode;
	wants_value = wants_value ^ _tmp1_;
	if (wants_value) {
		SudokuCell* _tmp2_;
		SudokuCell* _tmp3_;
		_tmp2_ = sudoku_view_get_selected_cell (self);
		_tmp3_ = _tmp2_;
		sudoku_cell_set_value (_tmp3_, key);
	} else {
		gboolean _tmp4_ = FALSE;
		SudokuGame* _tmp5_;
		GameMode _tmp6_;
		GameMode _tmp7_;
		_tmp5_ = self->priv->game;
		_tmp6_ = sudoku_game_get_mode (_tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_ == GAME_MODE_PLAY) {
			SudokuCell* _tmp8_;
			SudokuCell* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_tmp8_ = sudoku_view_get_selected_cell (self);
			_tmp9_ = _tmp8_;
			_tmp10_ = sudoku_cell_get_value (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp4_ = _tmp11_ == 0;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			gboolean enabled = FALSE;
			SudokuGame* _tmp12_;
			SudokuBoard* _tmp13_;
			SudokuBoard* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			_tmp12_ = self->priv->game;
			_tmp13_ = sudoku_game_get_board (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = self->priv->_selected_row;
			_tmp16_ = self->priv->_selected_col;
			enabled = sudoku_board_is_earmark_enabled (_tmp14_, _tmp15_, _tmp16_, key);
			if (!enabled) {
				SudokuGame* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				_tmp17_ = self->priv->game;
				_tmp18_ = self->priv->_selected_row;
				_tmp19_ = self->priv->_selected_col;
				sudoku_game_enable_earmark (_tmp17_, _tmp18_, _tmp19_, key);
			} else {
				SudokuGame* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				_tmp20_ = self->priv->game;
				_tmp21_ = self->priv->_selected_row;
				_tmp22_ = self->priv->_selected_col;
				sudoku_game_disable_earmark (_tmp20_, _tmp21_, _tmp22_, key);
			}
		}
	}
}

void
sudoku_view_dismiss_picker (SudokuView* self)
{
	SudokuNumberPicker* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->number_picker;
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
}

static void
sudoku_view_real_dispose (GObject* base)
{
	SudokuView * self;
	SudokuFrame* _tmp0_;
	SudokuNumberPicker* _tmp1_;
	self = (SudokuView*) base;
	_tmp0_ = self->priv->frame;
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
	_tmp1_ = self->number_picker;
	gtk_widget_unparent ((GtkWidget*) _tmp1_);
	G_OBJECT_CLASS (sudoku_view_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_bin_get_type (), AdwBin));
}

gboolean
sudoku_view_get_earmark_mode (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_earmark_mode;
	return result;
}

void
sudoku_view_set_earmark_mode (SudokuView* self,
                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_earmark_mode (self);
	if (old_value != value) {
		self->priv->_earmark_mode = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_EARMARK_MODE_PROPERTY]);
	}
}

gboolean
sudoku_view_get_autoclean_earmarks (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_autoclean_earmarks;
	return result;
}

void
sudoku_view_set_autoclean_earmarks (SudokuView* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_autoclean_earmarks (self);
	if (old_value != value) {
		self->priv->_autoclean_earmarks = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY]);
	}
}

gboolean
sudoku_view_get_number_picker_second_click (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_number_picker_second_click;
	return result;
}

void
sudoku_view_set_number_picker_second_click (SudokuView* self,
                                            gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_number_picker_second_click (self);
	if (old_value != value) {
		self->priv->_number_picker_second_click = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY]);
	}
}

gboolean
sudoku_view_get_highlight_row_column (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlight_row_column;
	return result;
}

void
sudoku_view_set_highlight_row_column (SudokuView* self,
                                      gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_highlight_row_column (self);
	if (old_value != value) {
		self->priv->_highlight_row_column = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY]);
	}
}

gboolean
sudoku_view_get_highlight_block (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlight_block;
	return result;
}

void
sudoku_view_set_highlight_block (SudokuView* self,
                                 gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_highlight_block (self);
	if (old_value != value) {
		self->priv->_highlight_block = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY]);
	}
}

gboolean
sudoku_view_get_highlight_numbers (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlight_numbers;
	return result;
}

void
sudoku_view_set_highlight_numbers (SudokuView* self,
                                   gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_highlight_numbers (self);
	if (old_value != value) {
		self->priv->_highlight_numbers = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY]);
	}
}

gdouble
sudoku_view_get_value_zoom_multiplier (SudokuView* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_value_zoom_multiplier;
	return result;
}

static void
sudoku_view_set_value_zoom_multiplier (SudokuView* self,
                                       gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_value_zoom_multiplier (self);
	if (old_value != value) {
		self->priv->_value_zoom_multiplier = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY]);
	}
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_selected_row;
	return result;
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_selected_row (self);
	if (old_value != value) {
		self->priv->_selected_row = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_selected_col;
	return result;
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_view_get_selected_col (self);
	if (old_value != value) {
		self->priv->_selected_col = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
	}
}

static SudokuCell*
sudoku_view_get_selected_cell (SudokuView* self)
{
	SudokuCell* result;
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCell* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cells;
	_tmp0__length1 = self->priv->cells_length1;
	_tmp0__length2 = self->priv->cells_length2;
	_tmp1_ = self->priv->_selected_row;
	_tmp2_ = self->priv->_selected_col;
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
	result = _tmp3_;
	return result;
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_warnings;
	return result;
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_show_warnings = value;
	_tmp0_ = sudoku_view_get_show_warnings (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		sudoku_view_update_warnings (self);
	} else {
		sudoku_view_clear_all_warnings (self);
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
}

gboolean
sudoku_view_get_show_earmark_warnings (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_earmark_warnings;
	return result;
}

void
sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                       gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_show_earmark_warnings = value;
	_tmp0_ = sudoku_view_get_show_warnings (self);
	_tmp1_ = _tmp0_;
	sudoku_view_set_show_warnings (self, _tmp1_);
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY]);
}

gboolean
sudoku_view_get_solution_warnings (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_solution_warnings;
	return result;
}

void
sudoku_view_set_solution_warnings (SudokuView* self,
                                   gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_solution_warnings = value;
	_tmp0_ = sudoku_view_get_show_warnings (self);
	_tmp1_ = _tmp0_;
	sudoku_view_set_show_warnings (self, _tmp1_);
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY]);
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_possibilities;
	return result;
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	self->priv->_show_possibilities = value;
	_tmp2_ = sudoku_view_get_show_possibilities (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		SudokuGame* _tmp4_;
		GameMode _tmp5_;
		GameMode _tmp6_;
		_tmp4_ = self->priv->game;
		_tmp5_ = sudoku_game_get_mode (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp1_ = _tmp6_ != GAME_MODE_CREATE;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp7_ = FALSE;
		SudokuGame* _tmp8_;
		SudokuBoard* _tmp9_;
		SudokuBoard* _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		_tmp8_ = self->priv->game;
		_tmp9_ = sudoku_game_get_board (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = sudoku_board_get_previous_played_time (_tmp10_);
		_tmp12_ = _tmp11_;
		if (_tmp12_ == 0.0) {
			_tmp7_ = TRUE;
		} else {
			SudokuGame* _tmp13_;
			_tmp13_ = self->priv->game;
			_tmp7_ = sudoku_game_get_elapsed_time (_tmp13_) > 3.0;
		}
		_tmp0_ = _tmp7_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		SudokuGame* _tmp14_;
		_tmp14_ = self->priv->game;
		sudoku_game_enable_all_earmark_possibilities (_tmp14_);
	} else {
		SudokuGame* _tmp15_;
		_tmp15_ = self->priv->game;
		if (sudoku_game_get_current_stack_action (_tmp15_) == STACK_ACTION_ENABLE_ALL_EARMARK_POSSIBILITIES) {
			SudokuGame* _tmp16_;
			_tmp16_ = self->priv->game;
			sudoku_game_undo (_tmp16_);
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlighter;
	return result;
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_view_get_has_selection (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = self->priv->_selected_row;
		_tmp3_ = self->priv->_selected_col;
		sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, FALSE);
	}
	self->priv->_highlighter = value;
	_tmp4_ = sudoku_view_get_has_selection (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		gint _tmp6_;
		gint _tmp7_;
		_tmp6_ = self->priv->_selected_row;
		_tmp7_ = self->priv->_selected_col;
		sudoku_view_set_cell_highlighter (self, _tmp6_, _tmp7_, TRUE);
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
}

gboolean
sudoku_view_get_has_selection (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_selection;
	return result;
}

void
sudoku_view_set_has_selection (SudokuView* self,
                               gboolean value)
{
	SudokuCell* _tmp0_;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	g_return_if_fail (self != NULL);
	self->priv->_has_selection = value;
	_tmp0_ = sudoku_view_get_selected_cell (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = sudoku_view_get_has_selection (self);
	_tmp3_ = _tmp2_;
	sudoku_cell_set_selected (_tmp1_, _tmp3_);
	_tmp4_ = sudoku_view_get_has_selection (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		SudokuCell* _tmp6_;
		SudokuCell* _tmp7_;
		_tmp6_ = sudoku_view_get_selected_cell (self);
		_tmp7_ = _tmp6_;
		gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
	} else {
		SudokuNumberPicker* _tmp8_;
		_tmp8_ = self->number_picker;
		gtk_popover_popdown ((GtkPopover*) _tmp8_);
	}
	_tmp9_ = self->priv->_selected_row;
	_tmp10_ = self->priv->_selected_col;
	_tmp11_ = sudoku_view_get_has_selection (self);
	_tmp12_ = _tmp11_;
	sudoku_view_set_cell_highlighter (self, _tmp9_, _tmp10_, _tmp12_);
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY]);
}

ZoomLevel
sudoku_view_get_zoom_level (SudokuView* self)
{
	ZoomLevel result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_zoom_level;
	return result;
}

void
sudoku_view_set_zoom_level (SudokuView* self,
                            ZoomLevel value)
{
	ZoomLevel _tmp0_;
	ZoomLevel _tmp1_;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	g_return_if_fail (self != NULL);
	self->priv->_zoom_level = value;
	_tmp0_ = sudoku_view_get_zoom_level (self);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case ZOOM_LEVEL_SMALL:
		{
			sudoku_view_set_value_zoom_multiplier (self, 0.4);
			break;
		}
		case ZOOM_LEVEL_MEDIUM:
		{
			sudoku_view_set_value_zoom_multiplier (self, 0.5);
			break;
		}
		case ZOOM_LEVEL_LARGE:
		{
			sudoku_view_set_value_zoom_multiplier (self, 0.6);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp2_ = self->priv->cells;
	_tmp2__length1 = self->priv->cells_length1;
	_tmp2__length2 = self->priv->cells_length2;
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
		cell_collection = _tmp2_;
		cell_collection_length1 = _tmp2__length1 * _tmp2__length2;
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
			SudokuCell* _tmp3_;
			SudokuCell* cell = NULL;
			_tmp3_ = _g_object_ref0 (cell_collection[cell_it]);
			cell = _tmp3_;
			{
				SudokuCell* _tmp4_;
				_tmp4_ = cell;
				gtk_widget_queue_allocate ((GtkWidget*) _tmp4_);
				_g_object_unref0 (cell);
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_view_real_dispose;
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_EARMARK_MODE_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_EARMARK_MODE_PROPERTY] = g_param_spec_boolean ("earmark-mode", "earmark-mode", "earmark-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY] = g_param_spec_boolean ("autoclean-earmarks", "autoclean-earmarks", "autoclean-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY] = g_param_spec_boolean ("number-picker-second-click", "number-picker-second-click", "number-picker-second-click", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY] = g_param_spec_boolean ("highlight-row-column", "highlight-row-column", "highlight-row-column", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY] = g_param_spec_boolean ("highlight-block", "highlight-block", "highlight-block", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY] = g_param_spec_boolean ("highlight-numbers", "highlight-numbers", "highlight-numbers", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY] = g_param_spec_double ("value-zoom-multiplier", "value-zoom-multiplier", "value-zoom-multiplier", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-earmark-warnings", "show-earmark-warnings", "show-earmark-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY] = g_param_spec_boolean ("solution-warnings", "solution-warnings", "solution-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HAS_SELECTION_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY] = g_param_spec_enum ("zoom-level", "zoom-level", "zoom-level", TYPE_ZOOM_LEVEL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", TYPE_SUDOKU_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
	self->priv = sudoku_view_get_instance_private (self);
	self->priv->_earmark_mode = FALSE;
	self->priv->_selected_row = 0;
	self->priv->_selected_col = 0;
	self->priv->_has_selection = TRUE;
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->key_controller);
	_g_object_unref0 (self->priv->focus_controller);
	_g_object_unref0 (self->priv->game);
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->frame);
	_g_object_unref0 (self->priv->paused_label);
	_g_object_unref0 (self->number_picker);
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
	switch (property_id) {
		case SUDOKU_VIEW_EARMARK_MODE_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_earmark_mode (self));
		break;
		case SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_autoclean_earmarks (self));
		break;
		case SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_number_picker_second_click (self));
		break;
		case SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_highlight_row_column (self));
		break;
		case SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_highlight_block (self));
		break;
		case SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_highlight_numbers (self));
		break;
		case SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY:
		g_value_set_double (value, sudoku_view_get_value_zoom_multiplier (self));
		break;
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
		g_value_set_int (value, sudoku_view_get_selected_row (self));
		break;
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
		g_value_set_int (value, sudoku_view_get_selected_col (self));
		break;
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
		break;
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_show_earmark_warnings (self));
		break;
		case SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_solution_warnings (self));
		break;
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
		break;
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
		break;
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_has_selection (self));
		break;
		case SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY:
		g_value_set_enum (value, sudoku_view_get_zoom_level (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
	switch (property_id) {
		case SUDOKU_VIEW_EARMARK_MODE_PROPERTY:
		sudoku_view_set_earmark_mode (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY:
		sudoku_view_set_autoclean_earmarks (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY:
		sudoku_view_set_number_picker_second_click (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY:
		sudoku_view_set_highlight_row_column (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY:
		sudoku_view_set_highlight_block (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY:
		sudoku_view_set_highlight_numbers (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY:
		sudoku_view_set_value_zoom_multiplier (self, g_value_get_double (value));
		break;
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
		sudoku_view_set_selected_row (self, g_value_get_int (value));
		break;
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
		sudoku_view_set_selected_col (self, g_value_get_int (value));
		break;
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
		sudoku_view_set_show_earmark_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY:
		sudoku_view_set_solution_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
		sudoku_view_set_has_selection (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY:
		sudoku_view_set_zoom_level (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

gboolean
zoom_level_is_fully_zoomed_out (ZoomLevel self)
{
	gboolean result;
	switch (self) {
		case ZOOM_LEVEL_SMALL:
		{
			result = TRUE;
			return result;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
}

gboolean
zoom_level_is_fully_zoomed_in (ZoomLevel self)
{
	gboolean result;
	switch (self) {
		case ZOOM_LEVEL_LARGE:
		{
			result = TRUE;
			return result;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
}

ZoomLevel
zoom_level_zoom_in (ZoomLevel self)
{
	ZoomLevel result;
	switch (self) {
		case ZOOM_LEVEL_SMALL:
		{
			result = ZOOM_LEVEL_MEDIUM;
			return result;
		}
		case ZOOM_LEVEL_MEDIUM:
		{
			result = ZOOM_LEVEL_LARGE;
			return result;
		}
		case ZOOM_LEVEL_LARGE:
		{
			{
				g_warning ("view.vala:592: ZOOM already at maximum");
				result = ZOOM_LEVEL_LARGE;
				return result;
			}
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

ZoomLevel
zoom_level_zoom_out (ZoomLevel self)
{
	ZoomLevel result;
	switch (self) {
		case ZOOM_LEVEL_LARGE:
		{
			result = ZOOM_LEVEL_MEDIUM;
			return result;
		}
		case ZOOM_LEVEL_MEDIUM:
		{
			result = ZOOM_LEVEL_SMALL;
			return result;
		}
		case ZOOM_LEVEL_SMALL:
		{
			{
				g_warning ("view.vala:610: ZOOM already at minimum");
				result = ZOOM_LEVEL_SMALL;
				return result;
			}
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
zoom_level_get_type_once (void)
{
	static const GEnumValue values[] = {{ZOOM_LEVEL_NONE, "ZOOM_LEVEL_NONE", "none"}, {ZOOM_LEVEL_SMALL, "ZOOM_LEVEL_SMALL", "small"}, {ZOOM_LEVEL_MEDIUM, "ZOOM_LEVEL_MEDIUM", "medium"}, {ZOOM_LEVEL_LARGE, "ZOOM_LEVEL_LARGE", "large"}, {0, NULL, NULL}};
	GType zoom_level_type_id;
	zoom_level_type_id = g_enum_register_static ("ZoomLevel", values);
	return zoom_level_type_id;
}

GType
zoom_level_get_type (void)
{
	static volatile gsize zoom_level_type_id__once = 0;
	if (g_once_init_enter (&zoom_level_type_id__once)) {
		GType zoom_level_type_id;
		zoom_level_type_id = zoom_level_get_type_once ();
		g_once_init_leave (&zoom_level_type_id__once, zoom_level_type_id);
	}
	return zoom_level_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

